/*
 * This test program illustrates how a process may use the
 * Linux x86 Performance-Monitoring Counters interface to
 * monitor the execution of another process.
 * [XXX: incomplete. currently just tests that attach works]
 *
 * Copyright (C) 1999  Mikael Pettersson
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "libperfctr.h"

unsigned child_sleep_secs;
unsigned parent_sleep_secs;

int child_action(void)
{
    sleep(child_sleep_secs);
    write(1, "child sez hello\n", 16);
    /* sleep(child_sleep_secs); */	/* trigger zombie condition */
    return 0;
}

int parent_action(int pid)
{
    int fd;

    sleep(parent_sleep_secs);
    fd = perfctr_attach(pid);
    if( fd < 0 ) {
	perror("perfctr_attach");
	return 1;
    }
    sleep(parent_sleep_secs);
    close(fd);
    waitpid(pid, NULL, 0);
    return 0;
}

int test(void)
{
    int pid = fork();
    if( pid < 0 ) {
	perror("fork");
	return 1;
    } else if( pid == 0 )
	return child_action();
    else
	return parent_action(pid);
}

int main(int argc, const char **argv)
{
    if( argc != 3 )
	return 1;
    child_sleep_secs = atoi(argv[1]);
    parent_sleep_secs = atoi(argv[2]);

    return test();
}
